=== modified file 'drizzled/authentication.cc'
--- drizzled/authentication.cc	2008-10-22 01:23:15 +0000
+++ drizzled/authentication.cc	2008-12-16 00:06:22 +0000
@@ -54,8 +54,10 @@
 {
   authentication_st *authen;
 
-  if ((authen= (authentication_st *)malloc(sizeof(authentication_st))) == 0)
-      return(1);
+  authen= new authentication_st;
+
+  if (authen == NULL)
+    return 1;
 
   memset(authen, 0, sizeof(authentication_st));
 
@@ -74,7 +76,7 @@
 
   return(0);
 err:
-  free(authen);
+  delete authen;
   return(1);
 }
 
@@ -86,7 +88,7 @@
   if (authen && plugin->plugin->deinit)
     plugin->plugin->deinit(authen);
 
-  free(authen);
+  delete authen;
 
   return(0);
 }

=== modified file 'drizzled/configvar.cc'
--- drizzled/configvar.cc	2008-12-06 19:42:46 +0000
+++ drizzled/configvar.cc	2008-12-16 00:06:22 +0000
@@ -25,7 +25,7 @@
 {
   configvar_t *p;
 
-  p= (configvar_t *) malloc(sizeof(configvar_t));
+  p= new configvar_t;
   if (p == NULL) return 1;
   memset(p, 0, sizeof(configvar_t));
 
@@ -45,7 +45,7 @@
   return 0;
 
 err:
-  free(p);
+  delete p;
   return 1;
 }
 
@@ -64,7 +64,7 @@
     }
   }
 
-  if (p) free(p);
+  if (p) delete p;
 
   return 0;
 }

=== modified file 'drizzled/errmsg.cc'
--- drizzled/errmsg.cc	2008-12-06 19:42:46 +0000
+++ drizzled/errmsg.cc	2008-12-16 00:06:22 +0000
@@ -27,7 +27,7 @@
 {
   errmsg_t *p;
 
-  p= (errmsg_t *) malloc(sizeof(errmsg_t));
+  p= new errmsg_t;
   if (p == NULL) return 1;
   memset(p, 0, sizeof(errmsg_t));
 
@@ -54,7 +54,7 @@
   return 0;
 
 err:
-  free(p);
+  delete p;
   return 1;
 }
 
@@ -77,7 +77,7 @@
     }
   }
 
-  if (p) free(p);
+  if (p) delete p;
 
   return 0;
 }

=== modified file 'drizzled/logging.cc'
--- drizzled/logging.cc	2008-12-06 19:42:46 +0000
+++ drizzled/logging.cc	2008-12-16 00:06:22 +0000
@@ -25,7 +25,7 @@
 {
   logging_t *p;
 
-  p= (logging_t *) malloc(sizeof(logging_t));
+  p= new logging_t;
   if (p == NULL) return 1;
   memset(p, 0, sizeof(logging_t));
 
@@ -45,7 +45,7 @@
   return 0;
 
 err:
-  free(p);
+  delete p;
   return 1;
 }
 
@@ -64,7 +64,7 @@
     }
   }
 
-  if (p) free(p);
+  if (p) delete p;
 
   return 0;
 }

=== modified file 'drizzled/qcache.cc'
--- drizzled/qcache.cc	2008-12-06 19:42:46 +0000
+++ drizzled/qcache.cc	2008-12-16 00:06:22 +0000
@@ -25,7 +25,7 @@
 {
   qcache_t *p;
 
-  p= (qcache_t *) malloc(sizeof(qcache_t));
+  p= new qcache_t;
   if (p == NULL) return 1;
   memset(p, 0, sizeof(qcache_t));
 
@@ -45,7 +45,7 @@
   return 0;
 
 err:
-  free(p);
+  delete p;
   return 1;
 }
 
@@ -64,7 +64,7 @@
     }
   }
 
-  if (p) free(p);
+  if (p) delete p;
 
   return 0;
 }

=== modified file 'drizzled/replicator.cc'
--- drizzled/replicator.cc	2008-12-09 05:50:07 +0000
+++ drizzled/replicator.cc	2008-12-16 00:06:22 +0000
@@ -26,7 +26,7 @@
 {
   replicator_t *p;
 
-  p= (replicator_t *) malloc(sizeof(replicator_t));
+  p= new replicator_t;
   if (p == NULL) return 1;
   memset(p, 0, sizeof(replicator_t));
 
@@ -46,7 +46,7 @@
   return 0;
 
  err:
-  free(p);
+  delete p;
   return 1;
 }
 
@@ -65,7 +65,7 @@
         }
     }
 
-  if (p) free(p);
+  if (p) delete p;
 
   return 0;
 }

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2008-12-15 21:57:36 +0000
+++ drizzled/show.cc	2008-12-16 00:34:28 +0000
@@ -1509,7 +1509,7 @@
                               const char *prefix, Table *table,
                               bool ucase_names)
 {
-  MY_ALIGNED_BYTE_ARRAY(buff_data, SHOW_VAR_FUNC_BUFF_SIZE, long);
+  MY_ALIGNED_BYTE_ARRAY(buff_data, SHOW_VAR_FUNC_BUFF_SIZE, int64_t);
   char * const buff= (char *) &buff_data;
   char *prefix_end;
   /* the variable name should not be longer than 64 characters */

=== modified file 'drizzled/sql_lex.cc'
--- drizzled/sql_lex.cc	2008-12-15 04:45:43 +0000
+++ drizzled/sql_lex.cc	2008-12-16 00:40:59 +0000
@@ -340,7 +340,6 @@
   lex->in_sum_func= NULL;
 
   lex->is_lex_started= true;
-  return;
 }
 
 void lex_end(LEX *lex)
@@ -353,15 +352,8 @@
     lex->yacc_yyvs= 0;
   }
 
-  /* release used plugins */
-  plugin_unlock_list(0, (plugin_ref*)lex->plugins.buffer,
-                     lex->plugins.elements);
-  reset_dynamic(&lex->plugins);
-
   delete lex->result;
   lex->result= 0;
-
-  return;
 }
 
 
@@ -378,6 +370,7 @@
 
     return symbol->tok;
   }
+
   return 0;
 }
 
@@ -2098,10 +2091,6 @@
    sql_command(SQLCOM_END), option_type(OPT_DEFAULT), is_lex_started(0)
 {
 
-  my_init_dynamic_array2(&plugins, sizeof(plugin_ref),
-                         plugins_static_buffer,
-                         INITIAL_LEX_PLUGIN_LIST_SIZE,
-                         INITIAL_LEX_PLUGIN_LIST_SIZE);
   reset_query_tables_list(true);
 }
 

=== modified file 'drizzled/sql_lex.h'
--- drizzled/sql_lex.h	2008-12-15 07:27:18 +0000
+++ drizzled/sql_lex.h	2008-12-16 00:40:59 +0000
@@ -1286,10 +1286,6 @@
   Session *session;
   virtual_column_info *vcol_info;
 
-  /* maintain a list of used plugins for this LEX */
-  DYNAMIC_ARRAY plugins;
-  plugin_ref plugins_static_buffer[INITIAL_LEX_PLUGIN_LIST_SIZE];
-
   const CHARSET_INFO *charset;
   bool text_string_is_7bit;
   /* store original leaf_tables for INSERT SELECT and PS/SP */
@@ -1419,8 +1415,6 @@
   virtual ~LEX()
   {
     destroy_query_tables_list();
-    plugin_unlock_list(NULL, (plugin_ref *)plugins.buffer, plugins.elements);
-    delete_dynamic(&plugins);
   }
 
   TableList *unlink_first_table(bool *link_to_local);

=== modified file 'drizzled/sql_plugin.cc'
--- drizzled/sql_plugin.cc	2008-12-15 19:26:28 +0000
+++ drizzled/sql_plugin.cc	2008-12-16 01:34:24 +0000
@@ -521,7 +521,7 @@
 }
 
 
-static plugin_ref intern_plugin_lock(LEX *lex, plugin_ref rc)
+static plugin_ref intern_plugin_lock(LEX *, plugin_ref rc)
 {
   st_plugin_int *pi= plugin_ref_to_int(rc);
 
@@ -539,8 +539,6 @@
     *plugin= pi;
     pi->ref_count++;
 
-    if (lex)
-      insert_dynamic(&lex->plugins, (unsigned char*)&plugin);
     return(plugin);
   }
   return(NULL);
@@ -725,39 +723,21 @@
   size_t count;
   uint32_t idx;
   struct st_plugin_int *plugin;
-  vector<st_plugin_int *> reap;
-  vector<st_plugin_int *>::reverse_iterator riter;
-
-  if (!reap_needed)
-    return;
-
 
   reap_needed= false;
   count= plugin_array.elements;
-  reap.reserve(count);
 
   for (idx= 0; idx < count; idx++)
   {
     plugin= *dynamic_element(&plugin_array, idx, struct st_plugin_int **);
-    if (plugin->state == PLUGIN_IS_DELETED && !plugin->ref_count)
-    {
-      /* change the status flag to prevent reaping by another thread */
-      plugin->state= PLUGIN_IS_DYING;
-      reap.push_back(plugin);
-    }
-  }
-
-  for (riter= reap.rbegin(); plugin= *riter, riter != reap.rend(); riter++)
+    plugin->state= PLUGIN_IS_DYING;
     plugin_deinitialize(plugin, true);
-
-  for (riter= reap.rbegin(); plugin= *riter, riter != reap.rend(); riter++)
     plugin_del(plugin);
-
+  }
 }
 
-static void intern_plugin_unlock(LEX *lex, plugin_ref plugin)
+static void intern_plugin_unlock(LEX *, plugin_ref plugin)
 {
-  int i;
   st_plugin_int *pi;
 
   if (!plugin)
@@ -767,22 +747,6 @@
 
   free((void *) plugin);
 
-  if (lex)
-  {
-    /*
-      Remove one instance of this plugin from the use list.
-      We are searching backwards so that plugins locked last
-      could be unlocked faster - optimizing for LIFO semantics.
-    */
-    for (i= lex->plugins.elements - 1; i >= 0; i--)
-      if (plugin == *dynamic_element(&lex->plugins, i, plugin_ref*))
-      {
-        delete_dynamic_element(&lex->plugins, i);
-        break;
-      }
-    assert(i >= 0);
-  }
-
   assert(pi->ref_count);
   pi->ref_count--;
 
@@ -913,8 +877,6 @@
   struct st_mysql_plugin **builtins;
   struct st_mysql_plugin *plugin;
   struct st_plugin_int tmp, *plugin_ptr;
-  vector<st_plugin_int *> reap;
-  vector<st_plugin_int *>::reverse_iterator riter;
   MEM_ROOT tmp_root;
 
   if (initialized)
@@ -995,8 +957,6 @@
   /*
     Now we initialize all remaining plugins
   */
-  reap.reserve(plugin_array.elements);
-
   for (idx= 0; idx < plugin_array.elements; idx++)
   {
     plugin_ptr= *dynamic_element(&plugin_array, idx, struct st_plugin_int **);
@@ -1005,21 +965,12 @@
       if (plugin_initialize(plugin_ptr))
       {
         plugin_ptr->state= PLUGIN_IS_DYING;
-        reap[idx]= plugin_ptr;
+        plugin_deinitialize(plugin_ptr, true);
+        plugin_del(plugin_ptr);
       }
     }
   }
 
-  /*
-    Check if any plugins have to be reaped
-  */
-  for(riter= reap.rbegin();
-      plugin_ptr= *riter, riter != reap.rend();
-      riter++)
-  {
-    plugin_deinitialize(plugin_ptr, true);
-    plugin_del(plugin_ptr);
-  }
 
 end:
   free_root(&tmp_root, MYF(0));
@@ -2014,22 +1965,8 @@
 
 void plugin_sessionvar_cleanup(Session *session)
 {
-  uint32_t idx;
-  plugin_ref *list;
-
   unlock_variables(session, &session->variables);
   cleanup_variables(session, &session->variables);
-
-  if ((idx= session->lex->plugins.elements))
-  {
-    list= ((plugin_ref*) session->lex->plugins.buffer) + idx - 1;
-    while ((unsigned char*) list >= session->lex->plugins.buffer)
-      intern_plugin_unlock(NULL, *list--);
-  }
-
-  reset_dynamic(&session->lex->plugins);
-
-  return;
 }
 
 

